package co.yixiang.yshop.module.member.service.usertagref;

import java.util.*;
import javax.validation.*;

import co.yixiang.yshop.module.member.controller.admin.user.vo.UserPageReqVO;
import co.yixiang.yshop.module.member.controller.admin.usertagref.vo.*;
import co.yixiang.yshop.module.member.dal.dataobject.usertagref.UserTagRefDO;
import co.yixiang.yshop.framework.common.pojo.PageResult;

/**
 * 用户标签中间 Service 接口
 *
 * @author admin
 */
public interface UserTagRefService {

    /**
     * 创建用户标签中间
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createUserTagRef(@Valid UserTagRefCreateReqVO createReqVO);

    /**
     * 更新用户标签中间
     *
     * @param updateReqVO 更新信息
     */
    void updateUserTagRef(@Valid UserTagRefUpdateReqVO updateReqVO);

    /**
     * 删除用户标签中间
     *
     * @param id 编号
     */
    void deleteUserTagRef(Long id);

    /**
     * 获得用户标签中间
     *
     * @param id 编号
     * @return 用户标签中间
     */
    UserTagRefDO getUserTagRef(Long id);

    /**
     * 获得用户标签中间列表
     *
     * @param ids 编号
     * @return 用户标签中间列表
     */
    List<UserTagRefDO> getUserTagRefList(Collection<Long> ids);

    /**
     * 获得用户标签中间分页
     *
     * @param pageReqVO 分页查询
     * @return 用户标签中间分页
     */
    PageResult<UserTagRefDO> getUserTagRefPage(UserTagRefPageReqVO pageReqVO);

    /**
     * 获得用户标签中间列表, 用于 Excel 导出
     *
     * @param exportReqVO 查询条件
     * @return 用户标签中间列表
     */
    List<UserTagRefDO> getUserTagRefList(UserTagRefExportReqVO exportReqVO);

    /**
     * 根据标签名称查询用户id
     *
     * @param pageReqVO /
     * @return /
     */
    List<Long> getUserIdByTagName(UserPageReqVO pageReqVO);

    void insertBatch(List<UserTagRefDO> doList);

    void deleteByUserId(Long id);

    Long selectCountByTagId(Long id);
}
